﻿<?xml version="1.0" encoding="utf-8"?>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd" MadCap:onlyLocalStylesheets="False">
    <head>
        <link href="../Resources/TableStyles/Default-Table.css" rel="stylesheet" MadCap:stylesheetType="table" /><title>Uploading Users using Schema Upload</title>
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" type="text/css" />
    </head>
    <body>
        <h1>Uploading Users using Schema Upload</h1>
        <p style="margin-left: 0.0px;text-align: left;">This section provides information about uploading users through the Schema upload method. This method uses a combination of CSV and SAV files.&#160;The CSV file is used for uploading the entitlement data and the corresponding SAV file must contain the mapping details required for storing the uploaded data in IGA.</p>
        <p>IGA provides samples of SAV and CSV files containing example values for user details. These sample files are listed in the below table:</p>
        <div class="table-wrap">
            <table style="width: 100%;mc-table-style: url('../Resources/TableStyles/Default-Table.css');margin-left: 0;margin-right: auto;" class="TableStyle-Default-Table" cellspacing="0">
                <col class="TableStyle-Default-Table-Column-Column1" />
                <col class="TableStyle-Default-Table-Column-Column1" />
                <col class="TableStyle-Default-Table-Column-Column1" />
                <thead>
                    <tr class="TableStyle-Default-Table-Head-Header1">
                        <th class="TableStyle-Default-Table-HeadE-Column1-Header1">SAV&#160;File Name</th>
                        <th class="TableStyle-Default-Table-HeadE-Column1-Header1">CSV FIle Name</th>
                        <th class="TableStyle-Default-Table-HeadD-Column1-Header1">Description</th>
                    </tr>
                </thead>
                <tbody>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyB-Column1-Body1">
                            <p class="table-text"><a href="../Resources/Attachments/USERS.sav">USERS.sav</a>
                            </p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyB-Column1-Body1">
                            <p class="table-text"><a href="../Resources/Attachments/users.csv">Users.csv</a>
                            </p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyA-Column1-Body1">Use the sample files to upload users.&#160;<ul><li><p class="table-text">Use the USERS.sav file to upload the mapping details.</p></li><li><p class="table-text">Use the&#160;Users.csv file to upload the user data.</p></li></ul></td>
                    </tr>
                </tbody>
            </table>
        </div>
        <h2>Contents of Upload Files</h2>
        <h3>USERS.sav File</h3>
        <p>The below table lists the properties of USERS.sav file.</p>
        <div class="table-wrap">
            <table style="width: 100%;mc-table-style: url('../Resources/TableStyles/Default-Table.css');" class="TableStyle-Default-Table" cellspacing="0">
                <col class="TableStyle-Default-Table-Column-Column1" style="width: 270px;" />
                <col class="TableStyle-Default-Table-Column-Column1" />
                <thead>
                    <tr class="TableStyle-Default-Table-Head-Header1">
                        <th class="TableStyle-Default-Table-HeadE-Column1-Header1">
                            <p class="table-text">Property</p>
                        </th>
                        <th class="TableStyle-Default-Table-HeadD-Column1-Header1">
                            <p class="table-text">Description</p>
                        </th>
                    </tr>
                </thead>
                <tbody>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">USER_NOT_IN_FILE_ACTION</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the actions to take for the users&#160;for the users who are not part of the file but present in IGA. The below options can be configured:</p>
                            <ul>
                                <li>
                                    <p class="table-text"><strong>INACTIVATE</strong>: Users who are not part of the file but present in IGA will be inactivated and a revoke task will be created to remove the user's access to their accounts.</p>
                                </li>
                                <li>
                                    <p class="table-text"><strong>NOACTION</strong>: No action will be taken on the users who are not part of the file but present in IGA.&#160;</p>
                                </li>
                            </ul>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">FILENAME</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the string that you want to add as a prefix to the name of the&#160;corresponding CSV file.&#160;When multiple CSV files with the same prefix are uploaded, all the files will be processed by IGA.</p>For example, if you specify&#160;Users for this property, then the CSV file name can be:&#160;<label class="filename-path">Users1.csv</label>,&#160;<label class="filename-path">Users_Import.csv, Users_Import_2.csv</label>, or any file name that starts with&#160;Users and has a .csv extension.</td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">DELIMITER</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the delimiter&#160;to use to separate the data items in the file.For examples, (,), (\).</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">SKIP_NUMBER_OF_LINES</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify how many lines to skip in the file.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">userReconcillationField</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify a value that you want schema import to use&#160;for mapping users.&#160;If the value of the attribute that you are uploading matches an existing attribute in IGA, the users value is updated, otherwise, a new user&#160;is created.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">GENERATESYSTEMUSERNAME</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify whether you want to&#160;generate a system username for the user you are uploading.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">GENERATEEMAIL</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify whether you want to&#160;generate an email id&#160;for the user you are uploading.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">EMAILTEMPLATE</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify an email template that must be used for notifying if the import fails.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyB-Column1-Body1">
                            <p class="table-text">MODIFYUSERDATAJSON</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyA-Column1-Body1">
                            <p class="table-text">Specify this parameter to use the inline processor for transforming the data that you want to import.&#160;(Available from Release v5.5 onwards)</p>
                            <p class="table-text">For example:&#160;</p>
                            <MadCap:codeSnippet>
                                <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                                <MadCap:codeSnippetCaption>JSON</MadCap:codeSnippetCaption>
                                <MadCap:codeSnippetBody MadCap:useLineNumbers="True" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: PlainText;">#MODIFYUSERDATAJSON={ "ADDITIONALTABLES" : { "USERS" : "SELECT 
USERKEY FROM USERS" }, "COMPUTEDCOLUMNS" : [ 
"customproperty1","customproperty2","customproperty3" ],
"PREPROCESSQUERIES" : [ "UPDATE NEWUSERDATA SET 
CUSTOMPROPERTY3 = (select count(USERKEY) from currentusers)", 
"CUSTOMFUNCTION###FUNCTION1" ], "CUSTOMFUNCTIONS" : { 
"FUNCTION1" : { "FULLCLASSNAME" : 
"com.saviynt.utility.connection.ConnectionUtlityService", "METHODNAME":
"doCustomPreprocess" } } }</MadCap:codeSnippetBody>
                            </MadCap:codeSnippet>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        <h3>Users.csv File</h3>
        <p>The below table lists the properties of Users.csv file.</p>
        <div class="table-wrap">
            <table style="width: 100%;mc-table-style: url('../Resources/TableStyles/Default-Table.css');" class="TableStyle-Default-Table" cellspacing="0">
                <col class="TableStyle-Default-Table-Column-Column1" style="width: 270px;" />
                <col class="TableStyle-Default-Table-Column-Column1" />
                <thead>
                    <tr class="TableStyle-Default-Table-Head-Header1">
                        <th class="TableStyle-Default-Table-HeadE-Column1-Header1">
                            <p class="table-text">Property</p>
                        </th>
                        <th class="TableStyle-Default-Table-HeadD-Column1-Header1">
                            <p class="table-text">Description</p>
                        </th>
                    </tr>
                </thead>
                <tbody>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Employee ID</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the unique employee ID for the user you are uploading. For example, 2310</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">FIRSTNAME</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the first name for the user you are uploading.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">LASTNAME</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the last name for the user you are uploading.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">COMPANYNAME</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the organization name for the user you are uploading. For example, Saviynt.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">LOCATION</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the location for the user you are uploading. For example, KM Lee.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">DEPARTMENTNAME</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the department for the user you are uploading.&#160;For example, CORPORATE.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">STATUSKEY</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the status value to mark the user's status.&#160;The below options can be configured:</p>
                            <ul style="text-align: left;">
                                <li>
                                    <p class="table-text"><strong>0: </strong>Inactive (Indicates that the current status of the user is inactive)</p>
                                </li>
                                <li>
                                    <p class="table-text"><strong>1: </strong>Active (Indicates that the current status of the user is active)</p>
                                </li>
                            </ul>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">CUSTOMPROPERTY</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the&#160;custom property value for the user you are uploading.&#160;</p>
                            <p style="text-align: left;" class="table-text">For example, CORPORATE ACCOUNT MANAGEMENT for the department or cost centre of the user.</p>
                            <p style="text-align: left;" class="table-text">Custom properties can also be used for updating the status of a user. For example, Active.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">DISPLAYNAME</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the name that has to be displayed in the Saviynt user interface.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">TITLE</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the title for the user you are uploading. For example, Mr., Miss.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyB-Column1-Body1">
                            <p class="table-text">USERNAME</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyA-Column1-Body1">
                            <p class="table-text">Specify a unique username for the user you are uploading. If you specify username in this field then IGA will not generate a username even if the&#160;<strong>GENERATESYSTEMUSERNAME </strong>field is enabled.</p>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        <h2 style="text-align: left;margin-left: 0.0px;" id="UploadingUsersusingSchemaUpload-UploadingtheUserDetails">Uploading the User Details</h2>
        <h3 style="text-align: left;margin-left: 0.0px;" id="UploadingUsersusingSchemaUpload-Prerequisites">Prerequisites</h3>
        <ul>
            <li>
                <p>Download the required sample CSV and SAV files, add the user details to them, and keep them ready for uploading.</p>
            </li>
            <li>
                <p>Ensure that the CSV file name must start with the string that you&#160;specified for the&#160;<strong>FILENAME&#160;</strong>property.</p>
            </li>
            <li style="text-align: left;">
                <p>Ensure that the SAV file name is suffixed with USERS.</p>
            </li>
        </ul>
        <h3 style="text-align: left;margin-left: 0.0px;" id="UploadingUsersusingSchemaUpload-UploadProcedure">Upload Procedure</h3>
        <ol>
            <li>
                <p>Click <strong>Admin &gt; Settings &gt; File Directory</strong>.<br />The <strong>File Directory</strong> page is displayed.</p>
            </li>
            <li>
                <p>Select the tab depending on the file you want to upload (<strong>SAV </strong>for uploading an SAV file, <strong>Datafiles </strong>for uploading a CSV file).&#160;</p>
            </li>
            <li>
                <p>Click the <strong>Upload</strong> icon or you can also select <strong>Upload New File</strong>.<br />The <strong>File To Upload</strong> dialog box is displayed.</p>
            </li>
            <li>
                <p>In the <strong>File To Upload</strong> dialog box, do the following:</p>
                <ol style="list-style-type: lower-alpha;">
                    <li>
                        <p>Click&#160;<strong>Select</strong>&#160;next to the&#160;<strong>Data File </strong>box.</p>
                    </li>
                    <li>
                        <p>Select the file you want to upload, and then click&#160;<strong>Open</strong>.<br />The selected file is displayed in&#160;the <strong>Data File </strong>box.</p>
                    </li>
                    <li>
                        <p>Click <strong>Upload</strong>. The newly uploaded file is added to IGA.</p>
                        <p>After the upload is successful, the <strong>File Uploaded Successfully</strong> message appears at the top of the page.</p>
                        <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
                            <p class="note">If an SAV file or a CSV file with the same name exists in IGA, the version of the newly uploaded file is incremented numerically. For example, if the USERS.sav file with version number 1 already exists, then version number 2 is assigned to the newly uploaded file.</p>
                        </div>
                    </li>
                </ol>
            </li>
            <li>
                <p class="auto-cursor-target">Create a new job from&#160;<strong>Admin &gt; Job Control Panel &gt; Add New Job</strong>.</p>
                <ol style="list-style-type: lower-alpha;">
                    <li>
                        <p class="auto-cursor-target">Select&#160;<strong>Job Type</strong> as&#160;<strong>SCHEMA &gt; SchemaUserJob</strong>.&#160;</p>
                    </li>
                    <li>
                        <p>Specify the <strong>Job Name</strong> and click<strong> Save</strong>.&#160;<br />If you are using IGA prior to Release v5.5.0, then select <strong>Admin &gt; Job Control Panel &gt; Add New Job &gt; </strong>select <strong>SCHEMA File based Users Import (SchemaUserjob) </strong>in<strong> Job Type</strong>. <br />Specify the Job Name to create a job trigger, specify the schedule details as per your requirement.</p>
                    </li>
                    <li>
                        <p>To start the job, click&#160;<strong>Action</strong>, then click&#160;<strong>START</strong>.</p>
                    </li>
                </ol>
            </li>
        </ol>
        <p>After&#160;the job is executed, the corresponding entitlement data is uploaded to IGA. The status of the job is available in&#160;<strong style="text-align: left;">Job History Details</strong>. If there is a mismatch in the&#160;number of columns in CSV and SAV files, it is captured in the&#160;<strong style="text-align: left;">Response&#160;</strong>column.</p>
    </body>
</html>